#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * GabbleSvcOLPCActivityProperties:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCActivityProperties GabbleSvcOLPCActivityProperties;

/**
 * GabbleSvcOLPCActivityPropertiesClass:
 *
 * The class of GabbleSvcOLPCActivityProperties.
 */
typedef struct _GabbleSvcOLPCActivityPropertiesClass GabbleSvcOLPCActivityPropertiesClass;

GType gabble_svc_olpc_activity_properties_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES \
  (gabble_svc_olpc_activity_properties_get_type ())
#define GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, GabbleSvcOLPCActivityProperties))
#define GABBLE_IS_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES))
#define GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, GabbleSvcOLPCActivityPropertiesClass))


typedef void (*gabble_svc_olpc_activity_properties_set_properties_impl) (GabbleSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_activity_properties_implement_set_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_set_properties_impl impl);
/**
 * gabble_svc_olpc_activity_properties_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_activity_properties_get_properties_impl) (GabbleSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_activity_properties_implement_get_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_get_properties_impl impl);
/**
 * gabble_svc_olpc_activity_properties_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
gabble_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

void gabble_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties);

/**
 * GabbleSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCBuddyInfo GabbleSvcOLPCBuddyInfo;

/**
 * GabbleSvcOLPCBuddyInfoClass:
 *
 * The class of GabbleSvcOLPCBuddyInfo.
 */
typedef struct _GabbleSvcOLPCBuddyInfoClass GabbleSvcOLPCBuddyInfoClass;

GType gabble_svc_olpc_buddy_info_get_type (void);
#define GABBLE_TYPE_SVC_OLPC_BUDDY_INFO \
  (gabble_svc_olpc_buddy_info_get_type ())
#define GABBLE_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfo))
#define GABBLE_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO))
#define GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfoClass))


typedef void (*gabble_svc_olpc_buddy_info_set_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_properties_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_properties_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*gabble_svc_olpc_buddy_info_set_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_activities_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_activities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_activities_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*gabble_svc_olpc_buddy_info_set_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_current_activity_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_set_current_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context);
static inline void
gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*gabble_svc_olpc_buddy_info_get_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_current_activity_impl impl);
/**
 * gabble_svc_olpc_buddy_info_return_from_get_current_activity:
 * @context: The D-Bus method invocation context
 * @out_activity: const gchar * (FIXME, generate documentation)
 * @out_channel: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel);
static inline void
gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel)
{
  dbus_g_method_return (context,
      out_activity,
      out_channel);
}

void gabble_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties);
void gabble_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities);
void gabble_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel);


G_END_DECLS
